//
//  CAreaPintadoView.m
//  PintadorIPhone
//
//  Created by rcanales on 13/02/10.
//  Copyright 2010 Autentia. All rights reserved.
//


#import "CAreaPintadoView.h"
#import "CoreGraphics/CoreGraphics.h"
#import "CObjetoGrafico.h"
#import "CRectangulo.h"
#import "CElipse.h"


// clase donde imlementamos todo el código particular de pintado
@implementation CAreaPintadoView

@synthesize tipo;	// nos ivocarán desde clases externas


// Metodo invocado cuando se carga desde un nib -initWithCoder:
- (id)initWithCoder:(NSCoder*)coder {		
	[super initWithCoder:coder];		// no olvidar invocar al padre para que se pinte el nib
	
	NSLog(@"Cargamos desde nib, buen momento para inicializar cosas");
	
	arrayObjetos = [[NSMutableArray alloc] init ];	// inicializamos el array
	tipo = 0;										// ponemos un tipo 0 por defecto
	
	return self;
}


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
    }
	
	NSLog(@"Inicializamos el frame");
	
    return self;
}

// cojemos la pulsación inicial
-(void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
	
	NSLog(@"Pulsado");
	CGPoint primerPunto;
	
	for (UITouch *touch in touches) {
		primerPunto = [touch locationInView:self];		// recuperamos coordenas locales
		break;											// ignoramos resto de touches
	}
	
	xtem = primerPunto.x;		//	Asociamos las auxiliares
	ytem = primerPunto.y;		
	
}


// de momento no nos interesa el movimiento
-(void) touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
	// NSLog(@"Movido");	
}


// al levantar los dedos
-(void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{	
	CObjetoGrafico* temporal = nil;		// creamos una objeto de la clase base
	
	CGPoint ultimoPunto;				// recuperamos coordenas
	
	for (UITouch *touch in touches) {	// ete bloque es igual que al pulsar pero no refactorizamos aposta
		ultimoPunto = [touch locationInView:self];
		break;
	}
	
	anchotem = ultimoPunto.x - xtem;	// calculamos ancho y alto
	altotem = ultimoPunto.y - ytem;
	
	if( tipo == 0)	// en función del tipo creamos un objeto distinto para usar polimorfismo
	{
		NSLog(@"Creamos rect");
		temporal = [[CRectangulo alloc] initConValores:xtem y:ytem ancho:anchotem alto:altotem];
		
	}
	else if (tipo == 1)
	{	
		NSLog(@"Creamos elipse");
		temporal = [[CElipse alloc] initConValores:xtem y:ytem ancho:anchotem alto:altotem];
	}
	else {
		NSLog(@"Error al elegir el tipo objeto");
		return;
	}
	
	NSLog(@"Soltado");
	
	[arrayObjetos addObject:temporal];	// añadimos elemento al array
	
	// indicamos que hay que refrescar la vista
	[self setNeedsDisplay];	// ojo que no lleva el :YES como aparece en algunos sitios de la doc
	
	
}



- (void)drawRect:(CGRect)rect {	// código invocado al pintar
	
	NSLog(@"Pintamos --En el CAreaPintado");
	
	CGContextRef contexto = UIGraphicsGetCurrentContext();
	
	//	Pintar los objetos delegando en la función polimorfica
	for ( CObjetoGrafico *elemento in arrayObjetos) {  	// usamos las enumeraciones rápidas
		[elemento traza];								// mostramos los datos en la consola de depuración
		[elemento pintate:contexto];					// pasamos contexto
	}	 
	
	
}

// como hemos hecho alloc debemos limpiar la memoria. Nunca se invoca dealloc directamente
- (void)dealloc {
    [super dealloc];
	
	NSLog(@"Borramos memoria");
	// no se nos olvide limpiar los objetos del array
	
	for ( CObjetoGrafico *elemento in arrayObjetos) {	// recorremos el array y pintamos
		[elemento release];
	}
	
	[arrayObjetos release];		// limpiamos el array en si mismo.
}

@end

