//
//  CObjetoGrafico.h
//  PintadorIPhone
//
//  Created by rcanales on 13/02/10.
//  Copyright 2010 Autentia. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "IPintable.h"

@interface CObjetoGrafico : NSObject <IPintable> { // No se puede declarar una clase abstracta en Objetive-C
	
@protected				// atributos protegidos porque queremos usarlos en clases derivadas polimorficas
	NSInteger x;		// punto x inicial donde pintar la figura
	NSInteger y;		// punto y inicial donde pintar la figura
	NSInteger ancho;	// ancho de la figura
	NSInteger alto;		// alto de la figura
}


// ojo que las propiedades no assign hay que liberarlas en dealloc
@property NSInteger x;
@property NSInteger y;
@property NSInteger ancho;
@property NSInteger alto;

// creamos el inicializador con los nombres de los atributos
-(id) initConValores:(NSInteger) px y:(NSInteger)py ancho:(NSInteger)pancho alto:(NSInteger)palto; 

-(void) traza;	// metodo para volcar en la consola el contenido de las variables

@end

// Como repaso, si queremos utilizar métodos particulares en clases hijas, recondar:
// isMemberOfClass	verifica si es de una clase concreta
// isKindOfClass	verifica si es de una derivada
